; metalooch -- RTcmix/gcl demo program.  This requires the "bradhacks"
; modifications to gcl-2.2.2 to run, plus it needs the "init.lsp" and
; "utils.lisp" files also included here.  It also needs the C program
; "mlslides" (compiled, of course) to send data into the metalooch program.

; run by saying  "gcl < metalooch.lsp" if all is set up...
; BGG



(setq pitches '(7.00 7.02 7.07 7.10 8.00 8.02 8.03 8.05 8.07 8.10 9.00 9.02))

(setq pwave 1.0)
(setq pstrum 0.1)
(setq psflute 0.1)

(defun metalooch() (prog(pitch slp)
	(system "mlslides &")
	(system "CMIX -i -n &")
	(sleep 2)
	(setq ss (rtcmix-socket-open "localhost" 1102))
	(setq d1 (rtcmix-socket-open "localhost" 7000))
	(rtcmix-socket-setnblock d1)
	(rtcmix-print "rtsetparams" '(22050 2) ss)
	(rtcmix-print "load" '("WAVETABLE") ss)
	(rtcmix-print "load" '("STRUM") ss)
	(rtcmix-print "load" '("METAFLUTE") ss)
	(setq slp 0)
again
	(setq pitch (getel pitches))

	(cond ((< (frandom 1.0) pwave)
		(rtcmix-print "makegen" '(1 10 1000 1 0.2 0.1) ss)
		(rtcmix-print "makegen" '(2 24 1000 0 0 1 1 2 0) ss)
		(rtcmix-print "WAVETABLE" `(0 7 4000 ,pitch 0) ss)
;		(rtcmix-print "WAVETABLE" 
;			`(0 7 4000 ,(+ pitch (frandom 0.002)) 0.5) ss)
		(rtcmix-print "WAVETABLE" 
			`(0 7 4000 ,(+ pitch (frandom 0.002)) 1) ss)))
	(cond ((< (frandom 1.0) pstrum) (emstrumish (+ (random 14) 8))))
	(cond ((< (frandom 1.0) psflute) (emflutish)))

	(checkvals (rtcmix-setifvals d1))

	(setq slp (const-frandom 1.0 4.0))
	(rtcmix-timer slp)
	(go again)
	)
)

(defun emstrumish(notes) (prog(base nlist st pch)
	(setq base (getel pitches))
	(setq nlist `(,base ,(+ base 1.0) ,(+ base 0.07) ,(+ base 0.19) ,(+ base 2.0) ,(- base 1.0)))
	(setq st 0)
more
	(cond ((= notes 0) (return t))
		(t (setq pch (getel nlist))
			(rtcmix-print "START" `(,st 0.5 ,pch 0.5 0.3 14000 2
				,(frandom 1.0) 1) ss)
			(setq st (+ st 0.1))
			(setq notes (- notes 1))
			(go more))
		)
	)
)

(setq flpitches '((84 20) (74 35) (112 19) (94 14)))

(defun emflutish() (prog(dice)
	(setq dice (frandom 1.0))
	(cond ((< dice 0.33) (sfluteit) (return t))
		((< dice 0.66) (bsfluteit) (return t))
		(t (vsfluteit) (return t))
		)
	)
)

(defun sfluteit() (prog(els)
	(rtcmix-print "makegen" '(1 24 1000 0 0 1 1 2 0) ss)
	(rtcmix-print "makegen" '(2 24 1000 0 0 1 1 2 0) ss)
	(setq els (getel flpitches))
	(rtcmix-print "SFLUTE" `(0 ,(const-frandom 7 15) 0.1 ,(car els) 
		,(cadr els) 3000 0 1) ss)
	(setq els (getel flpitches))
	(rtcmix-print "SFLUTE" `(0 ,(const-frandom 7 15) 0.1 ,(car els) 
		,(cadr els) 2500 1 1) ss)
	)
)

(defun vsfluteit() (prog(els)
	(rtcmix-print "makegen" '(1 24 1000 0 0 1 1 2 0) ss)
	(rtcmix-print "makegen" '(2 24 1000 0 0 1 1 2 0) ss)
	(setq els (getel flpitches))
	(rtcmix-print "makegen" '(3 10 1000 1) ss)
	(rtcmix-print "makegen" '(4 10 1000 1) ss)
	(rtcmix-print "VSFLUTE" `(0 ,(const-frandom 7 15) 0.1 
		,(car els) ,(+ 2 (car els))
		,(cadr els) ,(+ 3 (cadr els))
		2500 2 4 2 4 ,(frandom 1.0) 1) ss)
	)
)

(defun bsfluteit() (prog(el1 el2 dice)
	(rtcmix-print "makegen" '(1 24 1000 0 0 1 1 2 0) ss)
	(rtcmix-print "makegen" '(2 24 1000 0 0 1 1 2 0) ss)
	(setq el1 (getel flpitches))
	(setq el2 (getel flpitches))
	(setq dice (frandom 1.0))

	(cond ((< dice 0.3) (rtcmix-print "makegen"
			'(3 7 1000 0 500 1 100 0.9 50 1 50 0.8 100 0.95 50 0.87 50 1 100 0.99) ss))
		((< dice 0.6) (rtcmix-print "makegen"
			'(3 7 1000 1 100 0.9 50 1 50 0.8 100 0.95 50 0.87 50 1 100 0.99 500 0) ss))
		(t (rtcmix-print "makegen" '(3 7 1000 0 500 1 500 0) ss))
		)

	(setq dice (frandom 1.0))
	(cond ((< dice 0.3) (rtcmix-print "makegen"
			'(4 7 1000 0 500 1 100 0.9 50 1 50 0.8 100 0.95 50 0.87 50 1 100 0.99) ss))
		((< dice 0.6) (rtcmix-print "makegen"
			'(4 7 1000 1 100 0.9 50 1 50 0.8 100 0.95 50 0.87 50 1 100 0.99 500 0) ss))
		(t (rtcmix-print "makegen" '(4 7 1000 0 500 1 500 0) ss))
		)

	(rtcmix-print "BSFLUTE" `(0 ,(const-frandom 7 15) 0.1 
		,(car el1) ,(car el2)
		,(cadr el1) ,(cadr el2)
		2500 ,(frandom 1.0) 1) ss)
	)
)

(defun checkvals(vlist) (prog(key)
	(cond ((null (setq key (car vlist))) (return t)))
	(cond ((= key 0) (setq pwave (/ (rtcmix-getifval key) 100.0)) )
		((= key 1) (setq pstrum (/ (rtcmix-getifval key) 100.0)) )
		((= key 2) (setq psflute (/ (rtcmix-getifval key) 100.0)) )
		)
	(return (checkvals (cdr vlist)))
	)
)


(metalooch)
