/* mlslides.c -- motif slider set to send to gcl
 * for RTcmix/gcl demo program "metalooch.lsp"
 * BGG
*/

#include <Xm/Xm.h>
#include <Xm/BulletinB.h>
#include <Xm/Scale.h>
#include <Xm/Label.h>

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>

int s,ns;
struct sockaddr_in sss;

Widget topLevel;
Widget bboard;
Widget slidey1,slidey2,slidey3;
Widget sl1label,sl2label,sl3label;


XtAppContext app;


main(argc,argv)
int argc;
char *argv[];
{
	XmString text;
	int len,err;
	void Cslidey1();
	void Cslidey2();
	void Cslidey3();

/* open up the socket */
        if( (s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                perror("socket");
                exit(1);
                }

/* set up the socket address */
	sss.sin_family = AF_INET;
	sss.sin_addr.s_addr = INADDR_ANY;
	sss.sin_port = htons(7000); /* just made that one up... */

	if( err = bind(s, (struct sockaddr *)&sss, sizeof(sss)) < 0) {
		perror("bind");
		exit(1);
		}

	listen(s, 1);

	len = sizeof(sss);
	ns = accept(s, (struct sockaddr *)&sss, &len);
	if(ns < 0) {
		perror("accept");
		exit(1);
		}


	topLevel=XtVaAppInitialize(&app,"Mlslides",
		NULL,0,&argc,argv,NULL,NULL);

/* set up the main window */
	bboard = XtVaCreateManagedWidget("bboard",
		xmBulletinBoardWidgetClass, topLevel,
		XmNwidth, 700, XmNheight, 300, 
		XmNmarginWidth, 0, XmNmarginHeight, 0,NULL);

/* set up the sliders YAY TEAM!*/

	text=XmStringCreateSimple("WAVETABLE probability");
        sl1label=XtVaCreateManagedWidget("sl1label",
                xmLabelWidgetClass,bboard,XmNx,50,XmNy,30,
                XmNlabelString,text,NULL);
	slidey1 = XtVaCreateManagedWidget("slidey1",
		xmScaleWidgetClass, bboard,
		XmNx, 50, XmNy, 50, XmNshowValue, True,
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 600,
		XmNlabelString,text,XmNdecimalPoints,2,
                XmNvalue, 100, XmNscaleHeight, 20, NULL);

	XtAddCallback(slidey1,XmNvalueChangedCallback,Cslidey1,NULL);
	XtAddCallback(slidey1,XmNdragCallback,Cslidey1,NULL);

	text=XmStringCreateSimple("STRUM probability");
        sl2label=XtVaCreateManagedWidget("sl2label",
                xmLabelWidgetClass,bboard,XmNx,50,XmNy,130,
                XmNlabelString,text,NULL);
	slidey2 = XtVaCreateManagedWidget("slidey2",
		xmScaleWidgetClass, bboard,
		XmNx, 50, XmNy, 150, XmNshowValue, True,
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 600,
		XmNlabelString,text,XmNdecimalPoints,2,
                XmNvalue, 10, XmNscaleHeight, 20, NULL);

	XtAddCallback(slidey2,XmNvalueChangedCallback,Cslidey2,NULL);
	XtAddCallback(slidey2,XmNdragCallback,Cslidey2,NULL);

	text=XmStringCreateSimple("SFLUTE probability");
        sl3label=XtVaCreateManagedWidget("sl3label",
                xmLabelWidgetClass,bboard,XmNx,50,XmNy,230,
                XmNlabelString,text,NULL);
	slidey3 = XtVaCreateManagedWidget("slidey3",
		xmScaleWidgetClass, bboard,
		XmNx, 50, XmNy, 250, XmNshowValue, True,
                XmNorientation, XmHORIZONTAL,
                XmNmaximum, 100, XmNscaleWidth, 600,
		XmNlabelString,text,XmNdecimalPoints,2,
                XmNvalue, 10, XmNscaleHeight, 20, NULL);

	XtAddCallback(slidey3,XmNvalueChangedCallback,Cslidey3,NULL);
	XtAddCallback(slidey3,XmNdragCallback,Cslidey3,NULL);


	XtManageChild(bboard);

	XtRealizeWidget(topLevel);

	XtAppMainLoop(app);
}

void Cslidey1(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival,i;
	int svals[2];

	XmScaleGetValue(slidey1, &ival);

	svals[0] = 0;
	svals[1] = ival;

	write(ns, (void *)svals, sizeof(svals));
}

void Cslidey2(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival,i;
	int svals[2];

	XmScaleGetValue(slidey2, &ival);

	svals[0] = 1;
	svals[1] = ival;

	write(ns, (void *)svals, sizeof(svals));
}

void Cslidey3(w, client, call)
Widget w;
XtPointer client, call;
{
	int ival,i;
	int svals[2];

	XmScaleGetValue(slidey3, &ival);

	svals[0] = 2;
	svals[1] = ival;

	write(ns, (void *)svals, sizeof(svals));
}
